# Contributing

Thank you so much for wanting to contribute to the Password Generator! There are a couple ways to help out.
## Evangelize

Just tell people about the Password Generator. We believe that a bigger, more involved community makes for a better framework, and that better frameworks make the world a better place. We can always use more feedback.
## How to Contribute

Here are guides for submitting issues and pull requests.

### Bug Reports

If you encounter a bug that hasn't already been filed, please file a bug report. Let us know of things we should fix, things we should add, questions, etc.

Warning us of a bug is possibly the single most valuable contribution you can make to the Password Generator.

-   Head [here](https://github.com/sebastienrousseau/password-generator/issues/new) to submit a new issue.
-   Include a descriptive title that is straight to the point.
-   Write a detailed description on what the issue is all about.
-   Wait for someone to get to the issue and add labels.
-   The issue will be fixed soon!

### Code Contributions

Contributing code is one of the more difficult ways to contribute to the Password Generator.
#### Feature Requests

Filing feature requests is one of the most popular ways to contribute to the Password Generator.

Is there some feature request that you'd like to code up yourself? Is there a feature you asked for yourself that you'd like to code?

Here's how to contribute code for a new feature to the Password Generator. Pull Requests allow you to share your own code with us, and we can merge it into the main repo.
#### Adding Code

-   Fork the repo.
-   Clone the Password Generator repo by running: `git clone https://github.com/sebastienrousseau/password-generator.git`
-   Install Node.js if you haven't already, and run `npm install`. This installs the required dependencies for building the Password Generator.
-   Edit files in the `src/` folder. Don't edit any files in the `dist/` folder, this is only for distribution builds, which are automated.
-   Run `npm run build` to trigger builds, and the new distribution files will be in the `dist/` folder ready to go.
#### Fixing an Issue

Have you found a solution to an issue? Here is how you can submit your code to the Password Generator.

-   Fork the repo, and refer above for how to change up code.
-   Head to your local fork of the repo, and click the "New Pull Request" button.
-   Include a title that is straight to the point.
-   Wait for someone to review the pull request, and then merge your pull request!
